/* Fade through all colors */

#include <Wire.h>

/* Define the delay */
#define SPEED 20
#define ADDRESS 0xA0

void setup()
{
  /* Open I2C */
  Wire.begin();
  
  Wire.beginTransmission(0x48);  //Olimex ADDRESS
  Wire.write(0x05) ;             //MOD-RGB device type address
  Wire.write(ADDRESS);              //MOD-RGB address (0xA0 is the DEFAULT address)
  Wire.write(0x00);              //Stop PWM
  Wire.endTransmission();
  
  Wire.beginTransmission(0x48);  //Olimex ADDRESS
  Wire.write(0x05) ;             //MOD-RGB device type address
  Wire.write(ADDRESS);              //MOD-RGB address (0xA0 is the DEFAULT address)
  Wire.write(0x01);              //Start PWM
  Wire.endTransmission();
}

void loop()
{    
  
  unsigned char R, G, B; 
  
  for(int i = 0; i < 256; i++)
  {
     R = i;
     G = 0;
     B = 255; 
     Wire.beginTransmission(0x48);
     Wire.write(0x05);
     Wire.write(ADDRESS);
     Wire.write(0x03);
     Wire.write(R);
     Wire.write(G);
     Wire.write(B);
     Wire.endTransmission();   
     delay(SPEED);
  }
  
  for(int i = 0; i < 256; i++)
  {
     R = 255;
     G = 0;
     B = 255-i; 
     Wire.beginTransmission(0x48);
     Wire.write(0x05);
     Wire.write(ADDRESS);
     Wire.write(0x03);
     Wire.write(R);
     Wire.write(G);
     Wire.write(B);
     Wire.endTransmission();   
     delay(SPEED);
  }
  
  for(int i = 0; i < 256; i++)
  {
     R = 255;
     G = i;
     B = 0; 
     Wire.beginTransmission(0x48);
     Wire.write(0x05);
     Wire.write(ADDRESS);
     Wire.write(0x03);
     Wire.write(R);
     Wire.write(G);
     Wire.write(B);
     Wire.endTransmission();  
     delay(SPEED);
  }
  
    for(int i = 0; i < 256; i++)
  {
     R = 255-i;
     G = 255;
     B = 0; 
     Wire.beginTransmission(0x48);
     Wire.write(0x05);
     Wire.write(ADDRESS);
     Wire.write(0x03);
     Wire.write(R);
     Wire.write(G);
     Wire.write(B);
     Wire.endTransmission();   
     delay(SPEED);
  }
  
  for(int i = 0; i < 256; i++)
  {
     R = 0;
     G = 255;
     B = i; 
     Wire.beginTransmission(0x48);
     Wire.write(0x05);
     Wire.write(ADDRESS);
     Wire.write(0x03);
     Wire.write(R);
     Wire.write(G);
     Wire.write(B);
     Wire.endTransmission(); 
     delay(SPEED);  
  }
  
    for(int i = 0; i < 256; i++)
  {
     R = 0;
     G = 255-i;
     B = 255; 
     Wire.beginTransmission(0x48);
     Wire.write(0x05);
     Wire.write(ADDRESS);
     Wire.write(0x03);
     Wire.write(R);
     Wire.write(G);
     Wire.write(B);
     Wire.endTransmission();  
     delay(SPEED); 
  }

   
  
}
